﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Drawing;
using System.Windows.Forms;
using System.Drawing.Text;



namespace Scopa
{
    public partial class Form1 : Form
    {
        int[] nelMazzo;
        
        byte[] primiera = { 0, 16, 12, 13, 14, 15, 18, 21, 10, 10, 10 };
        int statoMazzo;
        int carteInMani = 0;
        int GiocatoreAttivo = 0;
        int PBoxSelezionata = 0;
        int ultimaPresa = 0;
        List<PictureBox> carteGiocatori = new List<PictureBox>();
        List<FlowLayoutPanel> FlowPrese = new List<FlowLayoutPanel>();
        List<GroupBox> Giocatore = new List<GroupBox>();
        struct Info // contiene i parametri di interesse allungabile all'occorrenza
        {
            public int IDcarta; // indice della carta
            public int IDpicBox; // indice della PictureBox
        }

        public Form1()
        {
            InitializeComponent();
#if (DEBUG) // in debug finestre d'aiuto
            listMazzo.Visible = true;
            listPOSSIBILIn.Visible = true;
            listSTATO.Visible = true;
#else // in release finestre d'aiuto nascoste
    listMazzo.Visible = false;
    listPOSSIBILIn.Visible = false;
    listSTATO.Visible = false;
#endif
            nelMazzo = new int[41];

            for (var i = 1; i <= 40; i++)
            {
                nelMazzo[i] = i; // creo un mazzo ordinato, base 1
            }

            // test mazzo che porta alla presa di 5 carte (improbabile nella realtà)
            // il mazzo non va mescolato
            //nelMazzo[13] = 2;
            //nelMazzo[14] = 12;
            //nelMazzo[15] = 22;
            //nelMazzo[16] = 32;
            //nelMazzo[1] = 5;
            //nelMazzo[4] = 20;
            //nelMazzo[7] = 23;
            //nelMazzo[10] = 11;


            //nelMazzo[2] = 30;
            //nelMazzo[12] = 14;
            //nelMazzo[22] = 15;
            //nelMazzo[32] = 16;
            //nelMazzo[5] = 1;
            //nelMazzo[20] = 4;
            //nelMazzo[23] = 7;
            //nelMazzo[11] = 10;
            //nelMazzo[30] = 13;


            // metto le PictureBox in una lista
            // con l'indice le recupero facilmente e senza cicli
            carteGiocatori.Add(mazzo);
            carteGiocatori.Add(Giocatore1_1);
            carteGiocatori.Add(Giocatore1_2);
            carteGiocatori.Add(Giocatore1_3);
            carteGiocatori.Add(Giocatore2_1);
            carteGiocatori.Add(Giocatore2_2);
            carteGiocatori.Add(Giocatore2_3);
            carteGiocatori.Add(Giocatore3_1);
            carteGiocatori.Add(Giocatore3_2);
            carteGiocatori.Add(Giocatore3_3);
            carteGiocatori.Add(Giocatore4_1);
            carteGiocatori.Add(Giocatore4_2);
            carteGiocatori.Add(Giocatore4_3);
            for (int i = 1; i < 13; i++)
            {
                carteGiocatori[i].Click += carteGiocatori_Click; // attivo l'evento
                carteGiocatori[i].MouseEnter += carteGiocatori_MouseEnter; // attivo l'evento
                carteGiocatori[i].MouseLeave += carteGiocatori_MouseLeave; // attivo l'evento
            }

            // metto i FlowLoyoutPanel in una lista
            // servono indicizzati per recuperarne il contenuto in base al numero giocatore
            FlowPrese.Add(flowLayoutPrese1); // fake
            FlowPrese.Add(flowLayoutPrese1);
            FlowPrese.Add(flowLayoutPrese2);
            FlowPrese.Add(flowLayoutPrese3);
            FlowPrese.Add(flowLayoutPrese4);

            // metto i GroupBox in una lista
            // servono indicizzati per recuperare le coordinte di dove
            // devono andare a finire le carte in animazione
            Giocatore.Add(Giocatore1);
            Giocatore.Add(Giocatore2);
            Giocatore.Add(Giocatore3);
            Giocatore.Add(Giocatore4);

            mazzo.BackgroundImage = ImageList1.Images[0]; // mostro il dorso sul mazzo
            labINFO.Text = "Scopa Napoletana, dai le carte...";
        }

        private void ButtDaiCarte_Click(object sender, EventArgs e)
        {
            ButtDaiCarte.Enabled = false;
            Random Rnd1 = new Random(DateTime.Now.Millisecond); // generatore random inizializzato a caso
            listPOSSIBILIs.Visible = false;
            lblScelta.Visible = false;
            timer1.Enabled = false;
            flowLayoutPrese1.Controls.Clear();
            flowLayoutPrese2.Controls.Clear();
            flowLayoutPrese3.Controls.Clear();
            flowLayoutPrese4.Controls.Clear();
            panelPUNTEGGI.Visible = false;
            flowLayoutPanelBANCO.BackgroundImage = Properties.Resources.panno;

            // mescolo il mazzo
            for (var i = 1; i <= 40; i++) // scambio l'IDcarta attuale, scegliendo 40 carte a caso
            {
                int rand = Rnd1.Next(1, 40);
                int tempCarta = nelMazzo[rand]; // inizio swap
                nelMazzo[rand] = nelMazzo[i];
                nelMazzo[i] = tempCarta; // fine swap
            }

            // svuoto e disabilito le picturebox dei giocatori
            for (int i = 1; i < 13; i++)
            {   
                carteGiocatori[i].BackgroundImage = null;
                carteGiocatori[i].Image = null;
                carteGiocatori[i].Enabled = false;
            }

            // elimino le picturebox nel banco
            flowLayoutPanelBANCO.Controls.Clear();
            listMazzo.Items.Clear();
            for (var i = 1; i <= 40; i++)
            {
                listMazzo.Items.Add(nelMazzo[i]); // mostro il mazzo (solo in debug)
            }

            daiLeCarte(1, 12);

            for (statoMazzo = 13; statoMazzo < 17; statoMazzo++)
            {   // prendo le carte dal mazzo e ne mostro 4 sul banco
                animazioneBanco(statoMazzo-13);
                PictureBox pp = new PictureBox();
                pp.Size = ImageList1.ImageSize;
                pp.SizeMode = PictureBoxSizeMode.Normal;
                pp.Image = ImageList1.Images[nelMazzo[statoMazzo]];
                pp.Name = Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[nelMazzo[statoMazzo]]);
                pp.Tag = nelMazzo[statoMazzo]; // sul banco mi è sufficiente sapere l'IDcarta
                flowLayoutPanelBANCO.Controls.Add(pp);
            }
            Application.DoEvents();

            statoMazzo = 16; // la prima mano è stata distribuita
            listMazzo.SelectedIndex = statoMazzo - 1; // evidenzio lo stato del mazzo (solo in debug)
            label1.Text = "Mazzo = " + (40 - statoMazzo) + " carte";
            GiocatoreAttivo = 0;
            attivaGiocatore(1);
            ButtDaiCarte.Enabled = true;
            MostraSTATO();
        }

        private void disattivaGiocatore(int G)
        {
            for (int gg = G * 3; gg < G * 3 + 3; gg++)
            {
                carteGiocatori[gg - 2].Enabled = false;
                if (carteGiocatori[gg - 2].BackgroundImage == null)
                {
                    carteGiocatori[gg - 2].Image = null; // non si verdrà nulla
                }
                else
                {
                    carteGiocatori[gg - 2].Image = ImageList1.Images[0]; // si verdrà il dorso
                }
            }
        }

        private void attivaGiocatore(int G)
        {
            for (int gg = G * 3; gg < G * 3 + 3; gg++)
            {
                if (carteGiocatori[gg - 2].BackgroundImage == null)
                {
                    carteGiocatori[gg - 2].Image = null; // non si verdrà nulla
                }
                else
                {
                    carteGiocatori[gg - 2].Image = null; // si verdrà la carta in BackgroundImage
                    carteGiocatori[gg - 2].Enabled = true;
                }
            }
            labINFO.Text = "E' il turno del giocatore n. " + G.ToString();
        }

        private void carteGiocatori_Click(object sender, EventArgs e)
        {
            PictureBox PB = (PictureBox)sender;
            if (PB.Tag == null) return;
            Info inf = (Info)PB.Tag; // in inf i parametri di interesse come dichiarato in struct Info
            PBoxSelezionata = inf.IDpicBox;
            ControlloPresa(inf.IDcarta);
            MostraSTATO();
        }

        private void ControlloPresa(int IDcarta)
        {
            int VALcartaGiocatore = IDcarta % 10;
            if (VALcartaGiocatore == 0) VALcartaGiocatore = 10; // se mod ha restituito 0, è il re di coppe'
            int QuanteSulBanco = flowLayoutPanelBANCO.Controls.Count;
            int[,] valori = new int[QuanteSulBanco, 2]; // conterrà i valori e gli ID delle carte sul banco

            for (int num = 0; num < QuanteSulBanco; num++)
            {   // recupero i valori e gli ID delle carte sul banco
                int VALcartaBanco = (int)flowLayoutPanelBANCO.Controls[num].Tag % 10;
                if (VALcartaBanco == 0) VALcartaBanco = 10;
                valori[num, 0] = VALcartaBanco;
                valori[num, 1] = (int)flowLayoutPanelBANCO.Controls[num].Tag; // ID carta
            }
            listPOSSIBILIs.Items.Clear();
            listPOSSIBILIn.Items.Clear();

            // possibili singole
            for (int prima = 0; prima < QuanteSulBanco; prima++)
            {
                if (valori[prima, 0] == VALcartaGiocatore)
                {   // in listPOSSIBILIs i nomi delle carte
                    listPOSSIBILIs.Items.Add(Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[valori[prima, 1]]));
                    // in listPOSSIBILIn gli ID delle carte
                    listPOSSIBILIn.Items.Add(valori[prima, 1]);
                }
            }

            // possibili doppie
            for (int prima = 0; prima < QuanteSulBanco; prima++)
            {
                for (int seconda = prima + 1; seconda < QuanteSulBanco; seconda++)
                {
                    if (valori[prima, 0] + valori[seconda, 0] == VALcartaGiocatore)
                    {   // in listPOSSIBILIs i nomi delle carte
                        listPOSSIBILIs.Items.Add(Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[valori[prima, 1]]) +
                            " / " + Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[valori[seconda, 1]]));
                        // in listPOSSIBILIn gli ID delle carte
                        listPOSSIBILIn.Items.Add(valori[prima, 1] + ";" + valori[seconda, 1]);
                    }
                }
            }

            // possibili triple
            for (int prima = 0; prima < QuanteSulBanco; prima++)
            {
                for (int seconda = prima + 1; seconda < QuanteSulBanco; seconda++)
                {
                    for (int terza = seconda + 1; terza < QuanteSulBanco; terza++)
                    {
                        if (valori[prima, 0] + valori[seconda, 0] + valori[terza, 0] == VALcartaGiocatore)
                        {   // in listPOSSIBILIs i nomi delle carte
                            listPOSSIBILIs.Items.Add(Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[valori[prima, 1]]) +
                                " / " + Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[valori[seconda, 1]]) +
                                " / " + Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[valori[terza, 1]]));
                            // in listPOSSIBILIn gli ID delle carte
                            listPOSSIBILIn.Items.Add(valori[prima, 1] + ";" + valori[seconda, 1] + ";" + valori[terza, 1]);
                        }
                    }
                }
            }

            // possibili rare quadruple
            for (int prima = 0; prima < QuanteSulBanco; prima++)
            {
                for (int seconda = prima + 1; seconda < QuanteSulBanco; seconda++)
                {
                    for (int terza = seconda + 1; terza < QuanteSulBanco; terza++)
                    {
                        for (int quarta = terza + 1; quarta < QuanteSulBanco; quarta++)
                        {
                            if (valori[prima, 0] + valori[seconda, 0] + valori[terza, 0] + valori[quarta, 0] == VALcartaGiocatore)
                            {   // in listPOSSIBILIs i nomi delle carte
                                listPOSSIBILIs.Items.Add(Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[valori[prima, 1]]) +
                                    " / " + Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[valori[seconda, 1]]) +
                                    " / " + Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[valori[terza, 1]]) +
                                    " / " + Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[valori[quarta, 1]]));
                                // in listPOSSIBILIn gli ID delle carte
                                listPOSSIBILIn.Items.Add(valori[prima, 1] + ";" + valori[seconda, 1] + ";" + valori[terza, 1] + ";" + valori[quarta, 1]);
                            }
                        }
                    }
                }
            }

            // quasi impossibili quintuple
            for (int prima = 0; prima < QuanteSulBanco; prima++)
            {
                for (int seconda = prima + 1; seconda < QuanteSulBanco; seconda++)
                {
                    for (int terza = seconda + 1; terza < QuanteSulBanco; terza++)
                    {
                        for (int quarta = terza + 1; quarta < QuanteSulBanco; quarta++)
                        {
                            for (int quinta = quarta + 1; quinta < QuanteSulBanco; quinta++)
                            {
                                if (valori[prima, 0] + valori[seconda, 0] + valori[terza, 0] + valori[quarta, 0] + valori[quinta, 0] == VALcartaGiocatore)
                                {   // in listPOSSIBILIs i nomi delle carte
                                    listPOSSIBILIs.Items.Add(Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[valori[prima, 1]]) +
                                        " / " + Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[valori[seconda, 1]]) +
                                        " / " + Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[valori[terza, 1]]) +
                                        " / " + Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[valori[quarta, 1]]) +
                                        " / " + Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[valori[quinta, 1]]));
                                    // in listPOSSIBILIn gli ID delle carte
                                    listPOSSIBILIn.Items.Add(valori[prima, 1] + ";" + valori[seconda, 1] + ";" + valori[terza, 1] + ";" + valori[quarta, 1] + ";" + valori[quinta, 1]);
                                }
                            }
                        }
                    }
                }
            }
            carteInMani -= 1;
            GiocatoreAttivo += 1;
            if (listPOSSIBILIs.Items.Count == 0)
            {   // scende la carta senza prendere nulla
                listPOSSIBILIs.Visible = false;
                lblScelta.Visible = false;
                timer1.Enabled = false;
                PictureBox pBanco = new PictureBox();
                Info inf = (Info)carteGiocatori[PBoxSelezionata].Tag; // in inf i parametri di interesse come dichiarato in struct Info

                pBanco = new PictureBox();
                pBanco.Size = ImageList1.ImageSize;
                pBanco.SizeMode = PictureBoxSizeMode.Normal;
                pBanco.Image = ImageList1.Images[inf.IDcarta];
                pBanco.Name = Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[inf.IDcarta]);
                pBanco.Tag = inf.IDcarta;
                flowLayoutPanelBANCO.Controls.Add(pBanco);
                carteGiocatori[PBoxSelezionata].BackgroundImage = null;
                carteGiocatori[PBoxSelezionata].Image = ImageList1.Images[45];
                if (GiocatoreAttivo == 4) { attivaGiocatore(1); disattivaGiocatore(4); GiocatoreAttivo = 0; } else { attivaGiocatore(GiocatoreAttivo + 1); disattivaGiocatore(GiocatoreAttivo); }
                if (carteInMani == 0) prossimo(); // la mano e finita, distribuzione carte
                MostraSTATO();
            }
            else
                if (listPOSSIBILIs.Items.Count == 1)
                Giocata(0); // c'è una sola possibilità, la giocata avviene in automatico               
            else
            {
                // ci sono più possibilità
                for (int i = GiocatoreAttivo * 3 - 2; i < GiocatoreAttivo * 3 + 1; i++)
                    carteGiocatori[i].Enabled = false; // disattivo le carte del giocatore, nessun ripensamento.

                carteGiocatori[PBoxSelezionata].Image = ImageList1.Images[42]; // selezione rossa

                // viene mostrata la scelta
                listPOSSIBILIs.Visible = true;
                lblScelta.Text = "?? Cosa desideri prendere con la carta: " + Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[IDcarta]) + " ??";
                lblScelta.Visible = true;
                timer1.Enabled = true;
                labINFO.Text = "Il giocatore n. " + GiocatoreAttivo + " ha giocato il " + Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[IDcarta]) + " e deve scegliere cosa prendere";
            }
        }

        private void listPOSSIBILIs_Click(object sender, EventArgs e)
        {
            if (listPOSSIBILIs.SelectedIndex < 0) return;
            Giocata(listPOSSIBILIs.SelectedIndex); // esegue giocata scelta
        }

        private void Giocata(int IndiceLB)
        {
            Info inf = (Info)carteGiocatori[PBoxSelezionata].Tag; // in inf i parametri di interesse come dichiarato in struct Info
            PictureBox pPresa = new PictureBox();
            string IDcarte = listPOSSIBILIn.Items[IndiceLB].ToString(); // recupero la stringa con gli ID delle carte scelte da listPOSSIBILIn
            string[] quali = IDcarte.Split(';'); // gli ID sono separati dai punto e virgola
            for (int i = 0; i < quali.Length; i++) // tutti gli ID
            {
                // creo una copia della carta nel banco, nel Tag l'ID della carta
                pPresa = new PictureBox();
                pPresa.Size = new Size(ImageList1.ImageSize.Width / 2, ImageList1.ImageSize.Height / 2); // dimensione ridotta
                pPresa.SizeMode = PictureBoxSizeMode.StretchImage;
                pPresa.Image = ImageList1.Images[Convert.ToInt32(quali[i])];
                pPresa.Name = Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[Convert.ToInt32(quali[i])]);
                pPresa.Tag = quali[i];
                FlowPrese[GiocatoreAttivo].Controls.Add(pPresa); // aggiungo la miniatura alle carte prese

                // cerco e tolgo la carta dal banco
                for (int pbBanco = 0; pbBanco < flowLayoutPanelBANCO.Controls.Count; pbBanco++)
                {
                  
                    if ((int)flowLayoutPanelBANCO.Controls[pbBanco].Tag == Convert.ToInt32(quali[i]))
                    {
                        flowLayoutPanelBANCO.Controls.RemoveAt(pbBanco);
                    }
                }
            }
            // creo una copia della carta giocata, nel Tag l'ID carta
            pPresa = new PictureBox();
            pPresa.Size = new Size(ImageList1.ImageSize.Width / 2, ImageList1.ImageSize.Height / 2); // dimensione ridotta
            pPresa.SizeMode = PictureBoxSizeMode.StretchImage;
            pPresa.Image = ImageList1.Images[inf.IDcarta];

            if (flowLayoutPanelBANCO.Controls.Count == 0) // se nel banco non ci sono carte... Scopa
            {   // aggiungo SCOPA nel nome, un rettangolo blu e la scritta sulla picturebox copiata
                pPresa.Name = Path.GetFileNameWithoutExtension("SCOPA " + ImageList1.Images.Keys[inf.IDcarta]);
                Graphics g = Graphics.FromImage(pPresa.Image);
                g.FillRectangle(Brushes.Blue, 0, 72, pPresa.Image.Width, pPresa.Image.Height - 72);
                g.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;
                g.DrawString("SCOPA", new Font("Arial Narrow", 15, FontStyle.Bold), Brushes.Yellow, -1, 76);
                g.Dispose();

                pictureBox1.Visible = true;
                flowLayoutPanelBANCO.Visible = false;
                Application.DoEvents();

                int pos = pictureBox1.Left;
                for (int i = 0; i < 170; i++)
                {
                    pos -= 2;
                    pictureBox1.Left = pos;
                    Application.DoEvents();
                    System.Threading.Thread.Sleep(1);
                }

                for (int i = 169; i > -1; i--)
                {
                    pictureBox1.Left = pos;
                    Application.DoEvents();
                    System.Threading.Thread.Sleep(1);
                    pos += 2;
                }
                pictureBox1.Visible = false;
                flowLayoutPanelBANCO.Visible = true;
            }
            else
            {
                // se non si è fatto Scopa, nel nome il nome della carta
                pPresa.Name = Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[inf.IDcarta]);
            }
            pPresa.Tag = inf.IDcarta;
            FlowPrese[GiocatoreAttivo].Controls.Add(pPresa); // aggiungo la miniatura della carta giocata alle carte prese
            // svuoto la carta giocata
            carteGiocatori[PBoxSelezionata].BackgroundImage = null;
            carteGiocatori[PBoxSelezionata].Image = ImageList1.Images[45];
            ultimaPresa = GiocatoreAttivo;
            if (GiocatoreAttivo == 4) { attivaGiocatore(1); disattivaGiocatore(4); GiocatoreAttivo = 0; } else { attivaGiocatore(GiocatoreAttivo + 1); disattivaGiocatore(GiocatoreAttivo); }
            if (carteInMani == 0) prossimo(); // la mano è finita, distribuzione carte
            listPOSSIBILIs.Visible = false;
            lblScelta.Visible = false;
            timer1.Enabled = false;
            MostraSTATO();
        }

        private void prossimo()
        {
            if (statoMazzo > 36)
            {
                // la partita è finita, assegno tutte le carte sul banco all'ultima presa
                while (flowLayoutPanelBANCO.Controls.Count > 0)
                {
                    PictureBox pPresa = new PictureBox();
                    pPresa = new PictureBox();
                    pPresa.Size = new Size(ImageList1.ImageSize.Width / 2, ImageList1.ImageSize.Height / 2); // dimensione ridotta
                    pPresa.SizeMode = PictureBoxSizeMode.StretchImage;
                    pPresa.Image = ImageList1.Images[Convert.ToInt32(flowLayoutPanelBANCO.Controls[0].Tag)];
                    pPresa.Name = Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[Convert.ToInt32(flowLayoutPanelBANCO.Controls[0].Tag)]);
                    pPresa.Tag = flowLayoutPanelBANCO.Controls[0].Tag;
                    FlowPrese[ultimaPresa].Controls.Add(pPresa); // aggiungo la miniatura alle carte prese
                   
                    flowLayoutPanelBANCO.Controls.RemoveAt(0);
                }
                labINFO.Text = "Fine Partita, dai le carte o guarda i punteggi";
                panelPUNTEGGI.Visible = true;
            }
            else
            {
                labINFO.Text = "Distribuisco le carte";
                daiLeCarte(statoMazzo + 1, statoMazzo + 12);
                attivaGiocatore(1);
                label1.Text = "Mazzo = " + (40 - statoMazzo) + " carte";
            }
        }

        private void daiLeCarte(int da, int a)
        {
            Info inf = new Info(); // in inf i parametri di interesse come dichiarato in struct Info
            int ind = 0;
            for (statoMazzo = da; statoMazzo < a + 1; statoMazzo++)
            {   // prendo 12 carte dal mazzo e le distribuisco ai 4 giocatori
                ind += 1;
                animazione(ind);
                carteGiocatori[ind].BackgroundImage = ImageList1.Images[nelMazzo[statoMazzo]];
                carteGiocatori[ind].Image = ImageList1.Images[0];
                carteGiocatori[ind].Name = Path.GetFileNameWithoutExtension(ImageList1.Images.Keys[nelMazzo[statoMazzo]]);
                // in inf tutti i dati utili
                inf.IDcarta = nelMazzo[statoMazzo];
                inf.IDpicBox = ind;
                carteGiocatori[ind].Tag = inf;
            }
            statoMazzo -= 1; // dal for si esce con una unità di troppo
            listMazzo.SelectedIndex = statoMazzo - 1;
            carteInMani = 12; // tutti i giocatori hanno 3 carte
        }

        private void animazione(int carta)
        {
            Point tmp = mazzo.Location;
            mazzo.BringToFront();
            Single r = carteGiocatori[carta].Top + Giocatore[(carta - 1) / 3].Top - mazzo.Top; // cordinata riga di arrivo
            Single c = carteGiocatori[carta].Left + Giocatore[(carta - 1) / 3].Left - mazzo.Left; // cordinata colonna di arrivo
            Single stepR = r / 50; // calcolo coordinate in 50 passi
            Single stepC = c / 50; // calcolo coordinate in 50 passi
            r = mazzo.Top; // coordinata di partenza
            c = mazzo.Left; // coordinata di partenza

            for (int i = 0; i < 50; i++)
            {
                r += stepR; // incremento in virgola mobile
                c += stepC; // incremento in virgola mobile
                mazzo.Top = Convert.ToInt16(r); // spostamnto alla nuova coordinata
                mazzo.Left = Convert.ToInt16(c); // spostamnto alla nuova coordinata
                //System.Threading.Thread.Sleep(1);
                Application.DoEvents(); // attesa visualizzazione
            }
            mazzo.Location = tmp;
        }

        private void animazioneBanco(int nCarta)
        {
            Point tmp = mazzo.Location;
            mazzo.BringToFront();
            Single r = flowLayoutPanelBANCO.Top - mazzo.Top + 8; // cordinata riga di arrivo
            Single c = flowLayoutPanelBANCO.Left - mazzo.Left + nCarta * 75; // cordinata colonna di arrivo
            Single stepR = r / 50; // calcolo coordinate in 50 passi
            Single stepC = c / 50; // calcolo coordinate in 50 passi
            r = mazzo.Top; // coordinata di partenza
            c = mazzo.Left; // coordinata di partenza

            for (int i = 0; i < 50; i++)
            {
                r += stepR; // incremento in virgola mobile
                c += stepC; // incremento in virgola mobile
                mazzo.Top = Convert.ToInt16(r); // spostamnto alla nuova coordinata
                mazzo.Left = Convert.ToInt16(c); // spostamnto alla nuova coordinata
                //System.Threading.Thread.Sleep(1);
                Application.DoEvents(); // attesa visualizzazione
            }
            mazzo.Location = tmp;
        }

        private void MostraSTATO() // solo in DEBUG
        {
            listSTATO.Items.Clear();
            listSTATO.Items.Add("carteInMani = " + carteInMani);
            listSTATO.Items.Add("GiocatoreAttivo = " + (GiocatoreAttivo + 1));
            listSTATO.Items.Add("PBoxSelezionata = " + PBoxSelezionata);
            string carte = "";
            Info inf = new Info(); // in inf i parametri di interesse come dichiarato in struct Info
            int ind = 0;
            for (int gg = 1; gg < 5; gg++)
            {
                carte = "";
                for (int i = 1; i < 4; i++)
                {
                    ind += 1;
                    if (carteGiocatori[ind].BackgroundImage != null)
                    {
                        inf = (Info)carteGiocatori[ind].Tag;
                        carte += "(" + inf.IDcarta + ")" + carteGiocatori[ind].Name + ";";
                    }
                }
                listSTATO.Items.Add("Giocatore" + gg + "= " + carte);
            }
            carte = "";
            for (int i = 0; i < flowLayoutPanelBANCO.Controls.Count; i++)
                carte += "(" + flowLayoutPanelBANCO.Controls[i].Tag + ")" + flowLayoutPanelBANCO.Controls[i].Name;

            listSTATO.Items.Add("Banco= " + carte);
            listSTATO.Items.Add("ultimaPresa = " + ultimaPresa);
        }

        private void buttGiocatore_Click(object sender, EventArgs e)
        {
            // interpretazione punteggio carte
            Button giocatoreButt = (Button)sender; // il bottone cliccato in giocatoreButt
            byte gioca = Convert.ToByte(giocatoreButt.Tag); // nel .Tag il numero del giocatore
            int carte = FlowPrese[gioca].Controls.Count; // nel giusto panel, il numero delle carte prese
            byte denari = 0;
            byte settebello = 0;
            byte scope = 0;
            byte miglioredenari = 0;
            byte migliorecoppe = 0;
            byte migliorespade = 0;
            byte migliorebastoni = 0;
            for (byte i = 0; i < FlowPrese[gioca].Controls.Count; i++) // esploro tutte le carte
            {
                byte valore = Convert.ToByte(FlowPrese[gioca].Controls[i].Tag); // nel .Tag l'ID della carta (1...40)
                if (FlowPrese[gioca].Controls[i].Name.Contains("bello")) settebello += 1; // aggiungo uno se settebello
                if (FlowPrese[gioca].Controls[i].Name.Contains("SCOPA")) scope += 1; // aggiungo 1 se scopa
                // per la primiera
                if (FlowPrese[gioca].Controls[i].Name.Contains("denari")) // esploro le denari
                {
                    denari += 1; // aggiungo 1 se denari
                    // memorizzo i punti più alti di primiera associati alla carta (vedi vettore primiera[])
                    if (primiera[valore - 10] > miglioredenari) miglioredenari = primiera[valore - 10];
                }
                if (FlowPrese[gioca].Controls[i].Name.Contains("coppe"))
                {   // memorizzo i punti più alti di primiera associati alla carta (vedi vettore primiera[])
                    if (primiera[valore] > migliorecoppe) migliorecoppe = primiera[valore];
                }
                if (FlowPrese[gioca].Controls[i].Name.Contains("bastoni"))
                {   // memorizzo i punti più alti di primiera associati alla carta (vedi vettore primiera[])
                    if (primiera[valore - 20] > migliorebastoni) migliorebastoni = primiera[valore - 20];
                }
                if (FlowPrese[gioca].Controls[i].Name.Contains("spade"))
                {   // memorizzo i punti più alti di primiera associati alla carta (vedi vettore primiera[])
                    if (primiera[valore - 30] > migliorespade) migliorespade = primiera[valore - 30];
                }
            }

            string testoPrimiera = $"coppe({migliorecoppe}) denari({miglioredenari}) bastoni({migliorebastoni}) spade({migliorespade})";
            byte valoreprimiera = 0;
            if (migliorebastoni>0 && migliorespade>0 && migliorecoppe>0 && miglioredenari>0)
            {   // calcolo i punti della primiera solo se il giocatore ha tutti i semi
                valoreprimiera = (byte)(migliorebastoni + migliorespade + migliorecoppe + miglioredenari);
            }
            stampapunteggio(gioca, carte, denari, settebello, scope, testoPrimiera, valoreprimiera);
        }

        private void carteGiocatori_MouseEnter(object sender, EventArgs e)
        {
            PictureBox PB = (PictureBox)sender;
            if (PB.BackgroundImage == null) return; // non sono state distribuite le carte
            PB.Image = ImageList1.Images[41]; // bordino blu (selezione)
        }

        private void carteGiocatori_MouseLeave(object sender, EventArgs e)
        {
            PictureBox PB = (PictureBox)sender;
            // se pb non è abilitato significa che si sta aspettando la scelta della giocata
            // Il bordino è rosso e non lo voglio cancellare
            if (PB.Enabled == false) return; 

            PB.Image = null; // nessun bordino (non selezionata)
        }

        private void stampapunteggio(int giocatore, int carte, byte denari, byte settebelllo, byte scope, string primiera, byte totaleprimiera)
        {
            Bitmap bmp = new Bitmap(Properties.Resources.panno.Width, Properties.Resources.panno.Height);
            Graphics g = Graphics.FromImage(bmp);
            g.DrawImage(Properties.Resources.panno, 0, 0, Properties.Resources.panno.Width, Properties.Resources.panno.Height);
            g.TextRenderingHint = TextRenderingHint.AntiAlias;
            g.DrawString($"Giocatore n. {giocatore}" , new Font("Arial Narrow", 20, FontStyle.Italic), Brushes.Yellow, 130, 10, StringFormat.GenericTypographic);
            g.DrawString($"Carte:             {carte}", new Font("Arial Narrow", 16, FontStyle.Italic), Brushes.White, 15, 50, StringFormat.GenericTypographic);
            g.DrawString($"Denari:           {denari}", new Font("Arial Narrow", 16, FontStyle.Italic), Brushes.White, 15, 80, StringFormat.GenericTypographic);
            g.DrawString($"SetteBello:     {settebelllo}", new Font("Arial Narrow", 16, FontStyle.Italic), Brushes.White, 15, 110, StringFormat.GenericTypographic);
            g.DrawString($"Scope:           {scope}", new Font("Arial Narrow", 16, FontStyle.Italic), Brushes.White, 15, 140, StringFormat.GenericTypographic);
            g.DrawString("Primiera: " + primiera, new Font("Arial Narrow", 14, FontStyle.Italic), Brushes.White, 15, 174, StringFormat.GenericTypographic);
            if (totaleprimiera == 0)
            {
                g.DrawString("TotalePrimiera = NON VALIDA", new Font("Arial Narrow", 14, FontStyle.Italic), Brushes.White, 15, 200, StringFormat.GenericTypographic);
            }
            else
            {
                g.DrawString("TotalePrimiera = " + totaleprimiera, new Font("Arial Narrow", 14, FontStyle.Italic), Brushes.White, 15, 200, StringFormat.GenericTypographic);
            }
             flowLayoutPanelBANCO.BackgroundImage = bmp;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            lblScelta.Enabled = ! lblScelta.Enabled;
        }
    }
}
